structure Arith = struct

    open DefInt

    val I = CONST o INT
    val True = CONST (BOOL true)
    val False = CONST (BOOL false)
    val V = VAR
    fun App (x, y) = APPL { opr = x, opnd = y }
    fun Lam (v, b) = LAMBDA { fp = v, body = b }
    fun If (p, c, a) = COND { prem = p, conc = c, altr = a }
    fun Letrec (f, v, fb, b) = LETREC { dvar = f, dexp = { fp = v, body = fb },
					body = b }
    fun Equal (x, y) = App (App (V"equal", x), y)
    fun Succ x = App (V"succ", x)

    val iter =
	Lam ("n",
	     Lam ("f",
		  Lam ("init",
		       Letrec ("loop", "i",
			       Lam ("a",
				    If (Equal (V"i", V"n"), V"a",
					App (App (V"loop", Succ (V"i")),
					     App (V"f",V"a")))),
			       App (App (V"loop", I 0), V"init")))))

    fun Iter (n, f, init) = App (App (App (iter, n), f), init)

    val pair = Lam ("x", Lam ("y", Lam ("s", If (V"s", V"x", V"y"))))
    val fst = Lam ("p", App (V"p", True))
    val snd = Lam ("p", App (V"p", False))

    fun Pair (x, y) = App (App (pair, x), y)
    fun Fst x = App (fst, x)
    fun Snd x = App (snd, x)

    val xsucc = Lam ("x", Pair (If (Snd (V"x"), I 0, Succ (Fst (V"x"))), False))
    fun XSucc x = App (xsucc, x)

    val xneg1 = Pair (I 0, True)

    val pred = Lam ("n", Fst (Iter (V"n", xsucc, xneg1)))
    fun Pred n = App (pred, n)

    val plus = Lam ("a", Lam ("b", Iter (V"a", V"succ", V"b")))
    val times = Lam ("a", Lam ("b", Iter (V"a", App (plus, V"b"), I 0)))

    fun Plus (a, b) = App (App (plus, a), b)
    fun Times (a, b) = App (App (times, a), b)

    val fact =
	Letrec ("f", "n",
		If (Equal (V"n", I 0), I 1,
		    Times (V"n", App (V"f", Pred (V"n")))),
		V"f")

    fun Fact n = App (fact, n)
end
