(* ol.sml
 *
 *   The object language (aka. "defined language").
 *   (Our defining language is SML.)
 *)
structure OL = struct

    type var = string

    datatype const = INT of int
		   | BOOL of bool

    datatype exp = CONST of const
		 | VAR of var
		 | APPL of { opr: exp, opnd: exp }
		 | LAMBDA of lambda
		 | COND of { prem: exp, conc: exp, altr: exp }
		 | LETREC of { dvar: var, dexp: lambda, body: exp }

    withtype lambda = { fp: var, body: exp }
end
